﻿SLASH_ASHCHATSLASH1 = "/ash"
SlashCmdList["ASHCHATSLASH"] = function(msg)
	AshChat:Slash(msg)
end

local function print(msg)		ChatFrame1:AddMessage("|cff00ddbaAshChat:|r "..msg)				end
local function printf(msg)
	local mmsg = string.gsub(msg, "(.*):(.*)", "|cfff48a21%1|r:%2")
	ChatFrame1:AddMessage(mmsg)
end

function AshChat:Slash(msg)
	local db = AshChatDB
	local param1 = string.lower(msg)
	local reset = false
	if (param1 == "button 0") then
		if db.ButtonStyle == 0 then
			return
		else
			db.ButtonStyle = 0;

			Ash_ButtonLoad()
--			Ash_HideScrollButtons();
			print("按鈕已設為系統樣式");
		end
	elseif (param1 == "button 1") then
		if db.ButtonStyle == 1 then
			return
		else
			db.ButtonStyle = 1;
			Ash_ButtonLoad();
			print("按鈕已設為自動隱藏樣式");
		end
	elseif (param1 == "button 2") then
		if db.ButtonStyle == 2 then
			return
		else
			db.ButtonStyle = 2;

			Ash_ButtonLoad();
--			Ash_HideScrollButtons();
			print("按鈕已設為藍色隱藏樣式,表情按鈕在聊天框的右上角")
		end
	elseif (param1 == "button") then
		print("當前按鈕模式為"..db.ButtonStyle..",輸入/ash button 0/1/2設置按鈕模式")
	elseif (param1 == "namecolor") then
--		if db.names then 
--			db.names = false
--			print("姓名染色已關閉")
--		else
			db.names = true
			print("請至聊天窗口的設置界面內選擇需要姓名染色的頻道")
--		end
	elseif (param1 == "showlevel") then
		if db.ShowLevel then 
			db.ShowLevel = false
			print("等級顯示已關閉")
		else
			db.ShowLevel = true
			print("等級顯示已開啟")
		end
	elseif (param1 == "urls") then
		if db.urls then 
			db.urls = false
			print("URL高亮/復制已關閉")
		else
			db.urls = true
			print("URL高亮/復制已開啟")
		end
	elseif (param1 == "highlight") then
		if db.highlight then 
			db.highlight = false
			print("關鍵字高亮已關閉")
		else
			db.highlight = true
			print("關鍵字高亮已開啟")
		end
	elseif (param1 == "shortchannel") then
		if db.ShortChannel then 
			db.ShortChannel = false
			print("頻道縮寫已關閉")
		else
			db.ShortChannel = true
			print("頻道縮寫已開啟")
		end
	elseif (param1 == "inputtop") then
		if db.InputTop then 
			db.InputTop = false
			AshChat_Top(false)
			print("輸入框已置底")
		else
			db.InputTop = true
			AshChat_Top(true)
			print("輸入框已頂置")
		end
	elseif (param1 == "whispersound") then
		if db.WhisperSound then 
			db.WhisperSound = false
			print("密語發聲已關閉")
		else
			db.WhisperSound = true
			print("密語發聲已開啟")
		end	
	elseif (param1 == "othersound") then
		if db.OtherChannelSound then 
			db.OtherChannelSound = false
			print("其他頻道發聲已關閉")
		else
			db.OtherChannelSound = true
			print("其他頻道發聲已開啟")
		end	
	elseif (param1 == "sticky") then
		if db.Sticky then 
			db.Sticky = false
			print("頻道保持已關閉")
		else
			db.Sticky = true
			print("頻道保持已開啟")
		end
	elseif (param1 == "noalt") then
		if db.ALT then 
			db.ALT = false
			ChatFrameEditBox:SetAltArrowKeyMode(false)
			print("現在無需按ALT即可移動光標,上下翻查")
		else
			db.ALT = true
			ChatFrameEditBox:SetAltArrowKeyMode(true)
			print("現在必須按ALT才可操作光標")
		end
	elseif (param1 == "timeoff") then
		db.Time = false
		print("所有時間標簽已關閉")
	elseif (param1 == "timeon") then
		db.Time = true
		print("所有時間標簽已開啟")
	elseif (param1 == "timesecond") then
		if db.Second then
			db.Second = false
			print("現在時間標簽按'時:分'格式顯示")
		else
			db.Second = true
			print("現在時間標簽按'時:分:秒'格式顯示")
		end
	elseif (param1 == "timequote") then
		if db.Timequote then
			db.Timequote = false
			print("時間標簽為不加括號樣式")
		else
			db.Timequote = true
			print("時間標簽已加括號")
		end
	elseif (param1 == "middle") then
		if db.NoMiddle then
			db.NoMiddle = false
			print("關鍵字高亮會在屏幕中部提示")
		else
			db.NoMiddle = true
			print("現在關鍵字高亮時不會在屏幕中部提示")
		end
	elseif (string.find(param1, "^(timecolor)")) then
		local _, _, _, value = string.find(param1, "timecolor(%s+)([^%s]+)");
		local color
		if value then
			color = string.sub(value,1,6)
		end
		if color and (color <= "ffffff") and (color >= "000000") and (string.len(color) >= 6)then
			db.TimeColor = '|cff'..color..'|HyChat|h%s|h|r %s'
			print("成功設置時間標簽色彩")
		else
			print("輸入/ash timecolor xxxxxx設置時間標簽的色彩")
			print("xxxxxx為000000-ffffff的值")
		end
	elseif (string.find(param1, "^(short)")) then
		local _, _, a, b = string.find(param1, "short%s+([^%s]+)%s+([^%s]+)");		
		--a = tonumber(a)
		if a and b then
			local duplicate = nil
			for i, v in ipairs(db.CustomChannel) do
				if v[1] == a then 
					v[2] = b
					duplicate = true
				end
			end
			if not duplicate then
				local n = table.getn(db.CustomChannel) + 1
				db.CustomChannel[n] = { a, b }
			end
			print("頻道["..a.."]->["..b.."]")
		else
			print("输入'/ash short 频道全名 缩写'设置自定义频道缩写")
			print("例: /ash short 大脚世界频道 大脚")
		end
	elseif (param1 == "highreset") then
		AshChat.HighReset()
		print("關鍵字列表已重置")
	elseif (param1 == "timecombat") then		
		if db.TimeBlacklist[2] then
			print("戰鬥記錄時間標簽已開啟")
			db.TimeBlacklist[2] = false
		else
			print("戰鬥記錄時間標簽已關閉")
			db.TimeBlacklist[2] = true
		end
	elseif (param1 == "ver") or (param1 == "version") then
		print(db.version)
	elseif (param1 == "friends")then
		if db.showfmb then
			db.showfmb = false
			AshChat_FMB(db.showfmb)
			print("好友按钮已移至聊天窗口右上角,菜单按钮左侧,并自动隐藏")
		else
			db.showfmb = true
			AshChat_FMB(db.showfmb)
			print("好友按钮已显示到聊天窗口左上")
		end
	elseif (param1 == "reset") then
		reset = true
		print("所有設置已設為默認值")
	elseif (param1 == "help") then
		print("設置命令:/ash空格加下列參數.\n例:/ash button 1")
		printf("  button 0/1/2:  設置按鈕樣式.0為系統默認,1為自動隱藏按鈕,2為藍色隱藏按鈕")
		printf("  namecolor: 設置是否姓名染色")
		printf("  showlevel: 設置是否顯示等級")
		printf("  urls: 是否將超鏈接高亮以點擊復制")
		printf("  highlight: 關鍵字高亮,Ctrl+右键暂时关掉當前关键字高亮")
		printf("  middle: 控制關鍵字高亮時是否在屏幕中部提示")
		printf("  highreset: 重置關鍵字列表,即啟用列表中所有關鍵字高亮")
		printf("  shortchannel: 頻道縮寫")
		printf("  short 频道全称 缩写: 设置自定义频道缩写")
		printf("  inputtop: 是否將輸入框頂置")
		printf("  whispersound: 是否密語發聲")
		printf("  othersound: 是否其它頻道發聲")
		printf("  noalt: 免ALT模式")
		printf("  timeoff: 關閉時間標簽")
		printf("  timeon: 開啟時間標籤")
		printf("  timesecond: 是否顯示秒")
		printf("  timequote: 時間標簽是否加括號")
		printf("  timecolor 顏色值: 設置時間標簽的色彩,顏色值為000000-ffffff的值")
		printf("  reset: 還原所有設置")
		printf("  ver: 查看插件版本")
		printf("  friends: 切换好友按钮隐藏/显示")
	else
		InterfaceOptionsFrame_OpenToCategory(AshChat_Panel);
		print("聊天增強,輸入/ash help查看更多幫助")
	end
	if reset then
		AshChatDB = AshChat_defaults
	else
		AshChatDB = db
	end
	AshChat:RefreshArg()
end
	