﻿--信息發聲,在組隊,公會,密語頻道有新消息時發聲
--自定義聲音請直接在audio目錄下替換,也可在此文件中查找相應的文件名,替換成你想要的文件名
--Whisper.mp3: 密語
--Party.wav: 隊伍
--Guild.wav: 公會
--Leader.mp3: 團長
local addon = CreateFrame("Frame")
local soundfileW = tostring("Interface\\AddOns\\AshChat\\audio\\Whisper.mp3")
local soundfileP = tostring("Interface\\AddOns\\AshChat\\audio\\Party.mp3")
local soundfileG = tostring("Interface\\AddOns\\AshChat\\audio\\Guild.mp3")
local soundfileL = tostring("Interface\\AddOns\\AshChat\\audio\\Leader.mp3")

function addon:CHAT_MSG_WHISPER()
	if AshChatDB.WhisperSound then
		PlaySoundFile(soundfileW)
	end
end
function addon:CHAT_MSG_BN_WHISPER()
	if AshChatDB.WhisperSound then
		PlaySoundFile(soundfileW)
	end
end
function addon:CHAT_MSG_GUILD(_,arg2,...)
	if (arg2 ~= UnitName("player")) and AshChatDB.OtherChannelSound then
		PlaySoundFile(soundfileG)
	end
end
function addon:CHAT_MSG_OFFICER(_,arg2,...)
	if (arg2 ~= UnitName("player")) and AshChatDB.OtherChannelSound then
		PlaySoundFile(soundfileG)
	end
end
function addon:CHAT_MSG_PARTY(_,arg2,...)
	if (arg2 ~= UnitName("player")) and AshChatDB.OtherChannelSound then
		PlaySoundFile(soundfileP)
	end
end
function addon:CHAT_MSG_PARTY_LEADER(_,arg2,...)
	if (arg2 ~= UnitName("player")) and AshChatDB.OtherChannelSound then	
		PlaySoundFile(soundfileL)
	end
end
function addon:CHAT_MSG_RAID(_,arg2,...)
	if (arg2 ~= UnitName("player")) and AshChatDB.OtherChannelSound then	
		PlaySoundFile(soundfileP)
	end
end
function addon:CHAT_MSG_RAID_LEADER(_,arg2,...)
	if (arg2 ~= UnitName("player")) and AshChatDB.OtherChannelSound then	
		PlaySoundFile(soundfileL)
	end
end

addon:SetScript("OnEvent",function(self, event, ...)
	if self[event] then
		self[event](self, ...)
	else
		self:UnregisterEvent(event)
	end
end
)
addon:RegisterEvent("CHAT_MSG_WHISPER")
addon:RegisterEvent("CHAT_MSG_BN_WHISPER")
addon:RegisterEvent("CHAT_MSG_GUILD")
addon:RegisterEvent("CHAT_MSG_OFFICER")
addon:RegisterEvent("CHAT_MSG_PARTY")
addon:RegisterEvent("CHAT_MSG_PARTY_LEADER")
addon:RegisterEvent("CHAT_MSG_RAID") 
addon:RegisterEvent("CHAT_MSG_RAID_LEADER")
addon:RegisterEvent("CHAT_MSG_CHANNEL")