﻿local flashTime = 0.5;
local addon = CreateFrame("Frame")
------------------------------------------------


--聊天翻頁按鈕樣式
local function hide(self)
	self:Hide()
end

function Ash_ScrollButton_OnUpdate(self, elapsed) 
	local parent = self:GetParent();
	local name = self:GetName();
	local pname = parent:GetName();
	local bottom = getglobal(name.."BottomButton");
	if (AshChatDB.ButtonStyle == 1) then
		if (AshChatDB.ButtonStyle == 1 and parent:IsVisible() and MouseIsOver(parent, 45, -10, -5, 5)) then
			getglobal(name.."UpButton"):Show();
			getglobal(name.."DownButton"):Show();
			getglobal(name.."BottomButton"):Show();
			getglobal(name.."MenuButton"):Show();

		else
			getglobal(name.."UpButton"):Hide();
			getglobal(name.."DownButton"):Hide();
			getglobal(name.."MenuButton"):Hide();
			if (parent:AtBottom()) then 
				bottom:Hide();
			else
				flashTime = flashTime - elapsed;
				if (flashTime <= 0) then
					if (bottom:IsVisible()) then
						bottom:Hide();
					else
						bottom:Show();
					end
					flashTime = 0.5;
				end
			end
		end
	else
		getglobal(name.."UpButton"):Hide();
		getglobal(name.."DownButton"):Hide();
		getglobal(name.."MenuButton"):Hide();
		getglobal(name.."BottomButton"):Hide();
	end
end

function Ash_HideChatButtons(pname, flag) 
   local up = getglobal(pname.."ButtonFrameUpButton");
   local down = getglobal(pname.."ButtonFrameDownButton");
   local bottom = getglobal(pname.."ButtonFrameBottomButton");
   local menu = getglobal("ChatFrameMenuButton");

	if (flag) then
--		bottom:SetScript("OnShow", hide);
		bottom:Hide();
		up:Hide();
		down:Hide();
		menu:Hide();
	else
		bottom:Show();
		up:Show();
		down:Show();
		menu:Show();
	end
end

function Ash_HideButtonFrame(flag) 
	for i=1, NUM_CHAT_WINDOWS do
		local bf = getglobal('ChatFrame'..i..'ButtonFrame')
		if flag then
			bf:SetScript("OnShow", hide)
			bf:Hide()
			ChatFrameMenuButton:SetScript("OnShow", hide);
			ChatFrameMenuButton:Hide()
		else
			bf:SetScript("OnShow", nil)
			bf:Show()
			ChatFrameMenuButton:SetScript("OnShow", nil);
			ChatFrameMenuButton:Show()
		end
	end
end

function Ash_ShowChatButtons(flag, mode)
	for i=1, NUM_CHAT_WINDOWS do
		Ash_HideButtonFrame(false);
		local cf = 'ChatFrame'..i;
		local bottom = getglobal(cf..'ButtonFrameBottomButton');
		local up = getglobal(cf..'ButtonFrameUpButton');
		local down = getglobal(cf..'ButtonFrameDownButton');
		local menu = getglobal("ChatFrameMenuButton");
		local bf = getglobal(cf..'ButtonFrame');
		Ash_HideChatButtons(cf, flag);
		
		if (mode == 2) then
		
			bf:SetWidth(0.1);
			
			up:SetScript("OnShow", hide);
			up:Hide();
			down:SetScript("OnShow", hide);
			down:Hide();
			
			bottom:ClearAllPoints();
			bottom:SetPoint("RIGHT", cf, "RIGHT", 0, 0);
			bottom:SetPoint("LEFT", cf, "RIGHT", -32, 0);
			bottom:SetPoint("TOP", cf, "BOTTOM", 0, 32);
			bottom:SetPoint("BOTTOM", cf, "BOTTOM", 0, 0);
			bottom:Show();
			bottom:DisableDrawLayer();
			
			menu:SetPoint("TOPRIGHT", "ChatFrame1", "TOPRIGHT", 0, 0);
			menu:SetPoint("BOTTOMLEFT", "ChatFrame1", "TOPRIGHT", -32, -32);
			menu:Show();
			menu:DisableDrawLayer()
			
		elseif (mode == 0) then
		
			bf:SetWidth(29);
			
			up:SetScript("OnShow", nil);
			up:Show();
			down:SetScript("OnShow", nil);
			down:Show();
			
			bottom:SetPoint("RIGHT", cf, "LEFT", 0, 0);
			bottom:SetPoint("LEFT", cf, "LEFT", -32, 0);
			bottom:SetPoint("TOP", cf, "BOTTOM", 0, 30);
			bottom:SetPoint("BOTTOM", cf, "BOTTOM", 0, 0);
			bottom:EnableDrawLayer();
			
			menu:SetPoint("TOPRIGHT", "ChatFrame1", "BOTTOMLEFT", 0, 126);
			menu:SetPoint("BOTTOMLEFT", "ChatFrame1", "BOTTOMLEFT", -32, 94);
			menu:EnableDrawLayer()
		end
	end
end
--初始化
function Ash_ButtonLoad()
	if AshChatDB.ButtonStyle == 0 then
		Ash_ShowChatButtons(false, 0);
	elseif AshChatDB.ButtonStyle == 1 then
		Ash_HideButtonFrame(true);
	elseif AshChatDB.ButtonStyle == 2 then
		Ash_ShowChatButtons(false, 2);
	end
end
addon:RegisterEvent("VARIABLES_LOADED");
addon:SetScript("OnEvent", Ash_ButtonLoad);
--聊天翻頁按鈕樣式END
