﻿	local AddOn = "|cFFFF7733NeonChat:|r "
	local oldalpha
	local color1,color2,color3,color4 = ChatFrame1Background:GetVertexColor()
	local TItable = { ChatFrame1ResizeTopLeftTexture, ChatFrame1ResizeTopTexture, ChatFrame1ResizeTopRightTexture, ChatFrame1ResizeRightTexture, ChatFrame1ResizeBottomRightTexture, ChatFrame1ResizeBottomTexture, ChatFrame1ResizeBottomLeftTexture, ChatFrame1ResizeLeftTexture, }

	local NeonChatDefaults = {
		background = 0.75,
		border = 1,
		--chatborder = "true",
		chatborder = false
	}
	local NeonChatDBv2=NeonChatDefaults

	select(6, ChatFrame1EditBox:GetRegions()):Hide()
	select(7, ChatFrame1EditBox:GetRegions()):Hide()
	select(8, ChatFrame1EditBox:GetRegions()):Hide()

	local editbox = CreateFrame("Button", nil, ChatFrame1EditBox)
	editbox:SetBackdrop({bgFile = "Interface\\ChatFrame\\ChatFrameBackground", edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", tile = true, tileSize = 16, edgeSize = 14, insets = {left = 3, right = 3, top = 3, bottom = 3}})
	editbox:ClearAllPoints()
	editbox:SetPoint("TOPLEFT", "ChatFrame1EditBoxLeft", "TOPLEFT", 2, -2)
	editbox:SetPoint("BOTTOMRIGHT", "ChatFrame1EditBoxRight", "BOTTOMRIGHT", -2, 2)
	editbox:SetFrameLevel(ChatFrame1EditBox:GetFrameLevel()-1)
	editbox:Show()
	
	for i = 1, NUM_CHAT_WINDOWS do
		local f = _G["ChatFrame"..i.."EditBox"]
		_G["ChatFrame"..i.."EditBoxLeft"]:Hide()
		_G["ChatFrame"..i.."EditBoxRight"]:Hide()
		_G["ChatFrame"..i.."EditBoxMid"]:Hide()
		_G["ChatFrame"..i.."EditBoxFocusLeft"]:SetTexture(nil)
		_G["ChatFrame"..i.."EditBoxFocusRight"]:SetTexture(nil)
		_G["ChatFrame"..i.."EditBoxFocusMid"]:SetTexture(nil)
		f:Hide()
	end
	

function AshChat_Top(flag)
	if flag then
		ChatFrame1EditBox:ClearAllPoints()
		ChatFrame1EditBox:SetPoint("BOTTOMLEFT", "ChatFrame1", "TOPLEFT", 0, 2)
		ChatFrame1EditBox:SetPoint("BOTTOMRIGHT", "ChatFrame1", "TOPRIGHT", 0, 2)
	else
		ChatFrame1EditBox:ClearAllPoints()
		ChatFrame1EditBox:SetPoint("TOPLEFT", "ChatFrame1", "BOTTOMLEFT", 0, -2)
		ChatFrame1EditBox:SetPoint("TOPRIGHT", "ChatFrame1", "BOTTOMRIGHT", 0, -2)
	end
end

	
	hooksecurefunc("ChatEdit_UpdateHeader", function()
		local type = ChatFrame1EditBox:GetAttribute("chatType")
		if ( type == "CHANNEL" ) then
			local id = GetChannelName(ChatFrame1EditBox:GetAttribute("channelTarget"))
			if id == 0 then
				editbox:SetBackdropBorderColor(0.5,0.5,0.5,NeonChatDBv2.border)
				if NeonChatDBv2.chatborder == "true" then
					for v,k in pairs(TItable) do
						k:SetVertexColor(color1,color2,color3,color4)
					end
				end
			else
				editbox:SetBackdropBorderColor(ChatTypeInfo[type..id].r,ChatTypeInfo[type..id].g,ChatTypeInfo[type..id].b,NeonChatDBv2.border)
				if NeonChatDBv2.chatborder == "true" then
					for v,k in pairs(TItable) do
						k:SetVertexColor(ChatTypeInfo[type..id].r,ChatTypeInfo[type..id].g,ChatTypeInfo[type..id].b,1)
					end
				end	
			end
		else
			editbox:SetBackdropBorderColor(ChatTypeInfo[type].r,ChatTypeInfo[type].g,ChatTypeInfo[type].b,NeonChatDBv2.border)
			if NeonChatDBv2.chatborder == "true" then
				for v,k in pairs(TItable) do
					k:SetVertexColor(ChatTypeInfo[type].r,ChatTypeInfo[type].g,ChatTypeInfo[type].b,1)
				end

			end
		end
		editbox:SetBackdropColor(ChatTypeInfo[type].r/10,ChatTypeInfo[type].g/10,ChatTypeInfo[type].b/10,NeonChatDBv2.background)
	end)
--[[
	hooksecurefunc(ChatFrame1EditBox, "Show", function()
		color1,color2,color3,color4 = ChatFrame1Background:GetVertexColor()
		oldalpha = ChatFrame1.oldAlpha
		ChatFrame1.oldAlpha = 1
		ChatFrame1.hasBeenFaded = nil
	end)

	hooksecurefunc(ChatFrame1EditBox, "Hide", function()
		ChatFrame1.oldAlpha = oldalpha
		ChatFrame1.hasBeenFaded = nil
		for v,k in pairs(TItable) do
			k:SetVertexColor(color1,color2,color3,color4)
		end
	end)
	]]--
function editbox:VARIABLES_LOADED()
	AshChat_Top(AshChatDB.InputTop);

end

editbox:SetScript("OnEvent", function(self, event, ...)
	if self[event] then
		--debug("Handling event "..event)
		self[event](self, ...)
	else
		--debug("No handler found for event "..event)
		self:UnregisterEvent(event)
	end
end)

editbox:RegisterEvent("VARIABLES_LOADED")